---
layout: cp
title: RandomX Audits
author: Howard Chu
date: 20 May 2019
amount: 1400
milestones:
  - name: Kudelski
    funds: 215
    done: 12 April 2019
    status: finished
  - name: X41
    funds: 555
    done: 10 May 2019
    status: finished
  - name: QuarksLab
    funds: 625
    done: 10 May 2019
    status: finished
payouts:
  - date: 30 May 2019
    amount: 1293.8
---

This is the funding request for the audits for the RandomX Proof of Work algorithm that we've
been working on for the past year or so. Our aim has been to develop a PoW that requires any
implementation to include the major components of a CPU, and thus constrain all implementations
to have CPU-like performance. The code for RandomX is available for testing on
https://github.com/tevador/RandomX/

We solicited proposals from 4 different audit teams. One of these is already being paid for
by Arweave.org. The community voted to fund the other 3, in this priority order. The vote
occurred on https://www.reddit.com/r/Monero/comments/bozr0z/randomx_auditor_selection/

Like with the Bulletproofs audit, We are working with the Open Source Technology Improvement Fund (OSTIF),
which has generously offered to manage the exchange of XMR to fiat to pay the reviewers.

REQUEST

1. Kudelski 18,250 CHF ~ $18,094.04
2. X41 42,000 Euro ~ $46,902.58
3. QuarksLab $52,800.00

The total amount is around $118,000 (and may vary due to exchange rate fluctuations from USD
to CHF and EUR). The request is for 1400 XMR, using an exhange estimate of 1 XMR = 85 USD. Since
the funding is in fiat currency, this amount will be updated to reflect price fluctuations
until funded.

The reviews will be funded in this order as soon as sufficient funds are available. This means
that as soon as enough funds have been raised to pay for Kudelski we will engage them to begin
their review. If/when sufficient funds are raised to pay for X41 we will start that; if/when
sufficient additional funds are raised to cover QuarksLab we will start that. If we don't raise
enough funds to cover all 3 reviews we will go with whatever we can cover. As with any other CCS
proposal, any funds collected that aren't sufficient to meet a funding target will be reverted
to the general development fund.

Reviews must be completed by end of June so that any identified problems can be fixed by July,
and ready for a code freeze and subsequent October release.
