---
layout: cp
title: "Sarang: research funding for 2020 Q3"
author: Sarang Noether
date: 28 May 2020
amount: 518
milestones:
  - name: Funding is released
    funds: 100% (475.21 XMR @ $65.75)
    done: 22 June 2020
    status: finished
  - name: Work is done
    funds: 0% (0 XMR)
    done: 30 September 2020
    status: finished
payouts:
  - date: 22 June 2020
    amount: 475.21
---
Hello! Dr. Sarang Noether here, ready to continue full-time research, development, and analysis in privacy-focused cryptography and applications. You can read my previous monthly reports for [April](https://repo.getmonero.org/monero-project/ccs-proposals/-/merge_requests/131#note_9896) and [May](https://repo.getmonero.org/monero-project/ccs-proposals/-/merge_requests/131#note_9975) to see what I've been up to recently. A report for June is forthcoming at the end of the quarter.

This funding request covers the period from July through September 2020. There's plenty to do, with a few big-ticket items in particular:
- CLSAG audit. The [CLSAG](https://eprint.iacr.org/2019/654) audit planning process (which has been quite the endeavor) is being finalized, and I will coordinate the technical efforts for this process.
- Arcturus applications. The [Arcturus](https://eprint.iacr.org/2020/312) proving system leads naturally to an efficient transaction protocol. Math and implementation involving multisignatures, cooperative signing, and anonymity set selection are ongoing.
- Protocol improvements. As always, research and development are ongoing to determine safe and efficient ways to improve transaction privacy, fungibility, and functionality while mitigating different types of adversarial heuristics.

And of course, there is always research and development that arises as we go. Expect code review, the usual updates and changes, outreach, literature review, proof-of-concept code and testing, documentation, and more.

I work hard to provide value in my research for the value provided here. As before, this request is for the equivalent of 10415 USD monthly, my assessment of fair market compensation for an independent Ph.D. researcher in the United States. Therefore, using an SMA-20 of 66.37 USD/XMR from Kraken with a 10% volatility buffer, the request total is **518 XMR**. To reduce the effects of price fluctuation, the XMR equivalent of the USD total for this request will be used to determine the amount for full payment when the request is filled. Any shortfall or excess at that time will be taken up by the general fund, as agreed to by the Monero core team.

Questions, comments, and feedback about this request are welcome.
